<?php

use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateSeoTables extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('seo_models', function (Blueprint $table) {
            $table->increments('id');
            $table->timestamps();

            $table->string('model_name', 191);
            $table->integer('model_id')->unsigned();
            $table->string('locale', 2);
            $table->string('key', 255);
            $table->text('value');

            $table->index(['model_name', 'model_id'], 'index_model');
        });

        Schema::create('seo_pages', function (Blueprint $table) {
            $table->increments('id');
            $table->timestamps();

            $table->string('page', 191);
            $table->string('locale', 2);
            $table->string('key', 255);
            $table->text('value');

            $table->index('page', 'index_page');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('seo_pages');

        Schema::dropIfExists('seo_models');
    }
}
