<?php

namespace AltSolution\Admin\Backup;

use Symfony\Component\Finder\Finder;
use ZipArchive;

class Code
{

    public function createArchive()
    {
        //$filePath = tempnam(sys_get_temp_dir(), 'cbkp') . '.zip';
        $filePath = storage_path('backup/code-'.date('YmdHis').'.zip');
        $fileDir = dirname($filePath);
        if (!is_dir($fileDir)) {
            mkdir($fileDir, 0777, true);
        }

        $basePath = base_path();
        $files = $this->listFiles($basePath);

        $zip = new ZipArchive;
        $opened = $zip->open($filePath, ZipArchive::CREATE);
        if ($opened !== true) {
            throw new \Exception('Failed open zip file');
        }
        foreach ($files as $file) {
            $realPath = $file->getRealPath();
            $relPath = substr($realPath, strlen($basePath)+1);
            $zip->addFile($realPath, $relPath);
        }
        $closed = $zip->close();
        if ($closed === false) {
            throw new \Exception('Failed close zip file');
        }

        return $filePath;
    }

    // https://symfony.com/doc/current/components/finder.html

    /**
     * @return \SplFileInfo[]
     */
    private function listFiles($dir)
    {
        $files = Finder::create()
            ->files()
            ->ignoreDotFiles(false)
            ->ignoreVCS(true)
            //->ignoreUnreadableDirs()
            ->exclude([
                'public/uploads',
                'public/vendor',
                'storage/framework',
                'vendor',
            ])
            ->in($dir)
            //->depth(0)
        ;

        return $files;
    }
}
