<?php

namespace AltSolution\Admin\Backup;

abstract class DumpFile
{
    /**
     * @var string
     */
    protected $filePath;

    /**
     * DumpFile constructor.
     * @param string $filePath
     */
    public function __construct($filePath)
    {
        $this->filePath = $filePath;
    }

    /**
     * @return void
     */
    abstract public function open();

    /**
     * @param string $str
     * @return void
     */
    abstract public function write($str);

    /**
     * @return void
     */
    abstract public function close();

    /**
     * @param string $filePath
     * @return DumpFile
     */
    public static function plain($filePath)
    {
        return new DumpFilePlain($filePath);
    }

    /**
     * @param string $filePath
     * @return DumpFile
     */
    public static function gzip($filePath)
    {
        return new DumpFileGzip($filePath);
    }
}
