<?php

namespace AltSolution\Admin\Form\Field;

use AltSolution\Admin\Form\AbstractField;

class Slug extends AbstractField
{
    protected $view = 'slug';
    protected $rules = [
        'regex:/^[a-z0-9_-]+$/',
    ];

    protected function customViewData()
    {
        $source = $this->transformName($this->getOption('source'));
        $enable = $this->normalizeBoolean($this->getOption('enable', false));
        if (!$enable) {
            $source = null;
        }
        return compact('source');
    }
}