<?php

namespace AltSolution\Admin\Option;

interface RepositoryInterface
{
    /**
     * Get option by name
     * @param string $name
     * @param mixed $default
     * @return string
     */
    public function get($name, $default = null);

    /**
     * Get options by names
     * @param string[] $names
     * @param mixed $default
     * @return string[]
     */
    public function getMany(array $names, $default = null);

    /**
     * Get all options
     * @return array
     */
    public function getAll();

    /**
     * Set option
     * @param string $name
     * @param string $value
     */
    public function set($name, $value);

    /**
     * Set many options
     * @param array $options
     */
    public function setMany(array $options);
}