<?php

namespace AltSolution\Admin\Providers;

use AltSolution\Admin\Forms\MenuForm;
use AltSolution\Admin\Forms\MenuItemForm;
use AltSolution\Admin\Http\Controllers\MenuController;
use AltSolution\Admin\Http\Controllers\MenuItemController;
use AltSolution\Admin\Models\Menu;
use AltSolution\Admin\Models\MenuItem;
use AltSolution\Admin\Modules\Menu\MenuFormInterface;
use AltSolution\Admin\Modules\Menu\MenuItemFormInterface;
use AltSolution\Admin\Modules\Menu\MenuModelInterface;
use AltSolution\Admin\Modules\Menu\MenuItemModelInterface;
use Illuminate\Support\ServiceProvider;

class MenuProvider extends ServiceProvider
{
    protected $defer = true;

    public function provides()
    {
        return [
            MenuFormInterface::class,
            MenuModelInterface::class,
            'admin.controller.menu',

            MenuItemFormInterface::class,
            MenuItemModelInterface::class,
            'admin.controller.menu_item',
        ];
    }

    public function register()
    {
        $this->app->bind(MenuFormInterface::class, MenuForm::class);
        $this->app->bind(MenuModelInterface::class, Menu::class);
        $this->app->instance('admin.controller.menu', MenuController::class);

        $this->app->bind(MenuItemFormInterface::class, MenuItemForm::class);
        $this->app->bind(MenuItemModelInterface::class, MenuItem::class);
        $this->app->instance('admin.controller.menu_item', MenuItemController::class);
    }
}
